boolean objectiveFound = false;        // true = Objekt gefunden , false = Objekt nicht gefunden, also sucht noch
float gradZahl;                        // Gradzahl um den der Roboter auf der Stelle drehen soll, wenn Objekt noch nicht gefunden ist
float messung=0;
int lichtschranke;

//Servos
#include <Servo.h>
Servo servoEntfernungsmesser;         // der Servo an dem der Entfernungsmesser befestigt sein soll, an digitalem Pin 8
Servo servoGreifarm1;                 // an analogem Pin A4
Servo servoGreifarm2;                 // an analogem Pin A5
Servo servoKlapp;                     // an analogem Pin A1
int pos;                              // akutelle Gradzahl des servoEntfernung zwischen 30 und 130 Grad 
int klapp;                            //Variable, die bestimmt, ob der Entfernungsmesser oben oder unten ist -> ServoKlapp

// Farbsensor Pins
#define S2 11
#define S3 12
#define S0 2
#define S1 3
#define sensorOUT 9
 
// Konstante für die Farbsensorkalibrierung: 
int R_WHITE = 68;
int R_BLACK = 750;
int G_WHITE = 92;
int G_BLACK = 960;
int B_WHITE = 64;
int B_BLACK = 670;
int C_WHITE = 32;
int C_BLACK = 360;

void setup() 
{
  Serial.begin(9600);
  Serial.println("ANFANG DES CODES");
  pinMode(10, OUTPUT);                  // Elektromagnet
  pinMode(13, OUTPUT);                  // LED von Lichtschranke
  digitalWrite(13, HIGH);               // LED ist ständig an
  digitalWrite(10, LOW);                // Elektromagnet ist am Anfang aus
  //Stepper
  pinMode(5, OUTPUT);                   // Step --> ein Schritt wird gemacht, wenn Step von LOW auf HIGH und wieder nach LOW wechselt
  pinMode(4, OUTPUT);                   // Direction --> vorwärts = HIGH, rückwärts = LOW
  // 4 und 5  gehören zum rechten Rad
  pinMode(7, OUTPUT);
  pinMode(6, OUTPUT);
  // 6 und 7 gehören zum linken Rad
  pinMode(A3, OUTPUT);                  // Step 
  pinMode(A2, OUTPUT);                  // Direction
  //Servo-Pins
  servoEntfernungsmesser.attach(8);
  servoKlapp.attach(A1);
  servoGreifarm1.attach(A4);
  servoGreifarm2.attach(A5);
  // Farbsensor
  pinMode(S2, OUTPUT);
  pinMode(S3, OUTPUT);
  pinMode(S0, OUTPUT);
  pinMode(S1, OUTPUT);
  digitalWrite(S0, HIGH);
  digitalWrite(S1, HIGH);
 
  servoGreifarm1.write(100);
  servoGreifarm2.write(180);
  servoKlapp.write(5);
  klapp=0;
  delay(1000);
  Serial.println("ende DES CODES");
  
}
void loop() 
{
  if(klapp==130 && objectiveFound==false){    //ServoKlapp herunterstellen, wenn objectiveFound=false und der Entfernungsmesser oben ist
    for(int i=0;i<125;i++){
    Serial.println(String(i));
    servoKlapp.write(130-i);
    delay(10);
    }
    klapp=0;                                  //der Entfernungsmesser ist unten
  }
  
lichtschranke = analogRead(A7);               // Diode von Lichtschranke
if (objectiveFound == false)                  // es wurde noch kein Objekt gefunden
  {
  Serial.println("OBJEKT FALSCH");
  pos = 130;
  servoEntfernungsmesser.write(pos);
  delay(500);
  Serial.println("SUCHE OBJEKT MIT SERVO");
  for (int i = 0; i < 100 && objectiveFound == false; i++)       // Servo von 130° (rechts) auf 30° (links) zurückbewegen
    {
      pos = pos -1;
      servoEntfernungsmesser.write(pos);                         //Drehung von 130 nach 30
      messung=analogRead(A6);
      Serial.println(messung);
      lichtschranke = analogRead(A7);
      Serial.println("pos:   " + String(pos));
      Serial.println("Lichtschranke  " + String(lichtschranke));
      if (messung > 300  || lichtschranke < 650)                 //wenn der Wert >300 ist, sieht er ein Objekt
        {
          Serial.println("OBJEKT JETZT WAHR");
          objectiveFound = true;
        }
      delay(50);
    }
  delay(1000);
  // nur, wenn ObjectiveFound=false
  Serial.println("JETZT NACH VORNE");
  straight(25);                                         
  Serial.println("GRAD DREHUNG"); 
  turn(90);
}
  // wenn ein Objekt gefunden wurde
  if (objectiveFound == true)    
    {
      Serial.println("OBJEKT WAHR");
      if (pos < 75)
        {
          Serial.println("DREHENLINKS");
          turnleft(80-pos);
        }
      if (pos > 75)
        {
          Serial.println("DREHENRECHTS");
          turnright(pos-70);
        }
      if (objectiveFound == true && lichtschranke > 650)        // wenn das Objekt genau vor dem Roboter liegt
        {
          Serial.println("FAHREGERADEAUS");
          Serial.println(messung);                              // ACHTUNG: hält noch nicht an, wenn das Ziel erreicht ist
          Serial.println(128330 * pow(messung,(-1.458)));
          straightTowardsGoal(128330 * pow(messung,(-1.458)));    // fährt um den aus dem Wert messung errechneten Weg nach vorne auf das Objekt zu
        }
                                                             
    
    if (objectiveFound == true && lichtschranke < 650) 
    {
      // Die map()-Funktion rechnet die Werte in den Bereich [0; 255] um:
      int rValue = map(sensorRead(0), R_BLACK, R_WHITE, 0, 255);
      int gValue = map(sensorRead(1), G_BLACK, G_WHITE, 0, 255);
      int bValue = map(sensorRead(2), B_BLACK, B_WHITE, 0, 255);
      int cValue = map(sensorRead(3), C_BLACK, C_WHITE, 0, 255);
      Serial.print("R: ");
      Serial.print(rValue);
      Serial.print("     G: ");
      Serial.print(gValue);
      Serial.print("     B: ");
      Serial.print(bValue);
      Serial.print("     C: ");         // "Clear" = alle Kanäle
      Serial.println(cValue);
      delay(100);
      if(cValue<150){
        Serial.println("dunkel"); 
        greifen(35);     // Hier weitermachen 
                         // bei 35 dreht sich der Stepper weniger beim Einsortieren der Objekte und dreht sich dann
                         //nachdem er die Objekte fallen gelassen hat auf die Uasgangsposition zurück   
        
      }
      if(cValue>150){
        Serial.println("hell");
       greifen(52);      // Hier weitermachen
                         //Stepper dreht sich drekt zur Ausgangsposition zurück
        
      }
    }
    }
     
    
}






//Funktion Roboter nach links drehen
void turn(float gradDrehen)
{
 
 float streckeRad = (25 * PI) / (360/gradDrehen);     // Durchmesser von Rad zu Rad -> 25 cm    
 float multiplikator = streckeRad / (PI * 9);         // multiplikator ist der Wert mit dem wir 230 (eine Umdrehung eines Rades)
 float stepAnzahl = 200 * multiplikator;              // multiplizieren um den Wert der Schritte für die benötigte Drehung zu erhalten -> benötigte Anzahl Steps bei der Drehung

 digitalWrite(4, HIGH);
 digitalWrite(6, LOW);
 
 for (int k = 0; k < stepAnzahl && objectiveFound == false; k++)    // auf der Stelle drehen, Rad links bewegt sich, Rad rechts hält an
      {
      Serial.println("Normale Drehung für nichts gefunden");
      messung=analogRead(A6);
      lichtschranke = analogRead(A7);
      if (messung > 300){
         pos=130;                         
         objectiveFound = true;     
      }                        
      digitalWrite(5, HIGH);            
      digitalWrite(7, HIGH);
      delayMicroseconds(500);             
      digitalWrite(5, LOW);             
      digitalWrite(7, LOW);             
      delayMicroseconds(500); 
      delay(50);
        }
}

//Funktion Roboter nach rechts drehen drehen, wenn Objekt gefunden
void turnright(float gradDrehen)
{
 
 float streckeRad = (25 * PI) / (360/gradDrehen);   // Durchmesser von Rad zu Rad -> 25 cm
 Serial.println(streckeRad);      
 float multiplikator = streckeRad / (PI * 9);        // multiplikator ist der Wert mit dem wir 230 (eine Umdrehung eines Rades)
 Serial.println(multiplikator);                      // multiplizieren um den Wert der Schritte für die benötigte Drehung zu erhalten -> 9 ist Durchmesser des Rades
 float stepAnzahl = (200 * multiplikator)/2;
 Serial.println(stepAnzahl);    // benötigte Anzahl Steps bei der Drehung

 digitalWrite(4, LOW);
 digitalWrite(6, HIGH);
 Serial.println("Funktion DREHENRECHTS wird ausgeführt");
 for (int k = 0; k < stepAnzahl; k++)
      { 
      digitalWrite(5, HIGH);            
      digitalWrite(7, HIGH);
      delayMicroseconds(500);             
      digitalWrite(5, LOW);             
      digitalWrite(7, LOW);             
      delayMicroseconds(500); 
      delay(50);
     
        }
          Serial.println("TEST2");
          pos = 75;                     // bei 75° guckt der Entfernungsmesser genau geradeaus!
          servoEntfernungsmesser.write(pos);
          delay(500);
          messung = analogRead(A6);
          if (messung < 300)
            {
              objectiveFound = false;
              Serial.println("TEST2 negativ -> kein Objekt mehr");
              klapp=0;           
            }
          if(messung > 300){             //ServoKlapp hochfahren
              for (int i=0; i<125; i++){
                servoKlapp.write(5+i);
                delay(50);
                }
                klapp=130;
              }
}


//Funktion Roboter nach links drehen, wenn Objekt gefunden
void turnleft(float gradDrehen)
{
 
 float streckeRad = (25 * PI) / (360/gradDrehen);    // Durchmesser von Rad zu Rad -> 25 cm
 Serial.println(streckeRad);      
 float multiplikator = streckeRad / (PI * 9);        // multiplikator ist der Wert mit dem wir 230 (eine Umdrehung eines Rades)
 Serial.println(multiplikator);                      // multiplizieren um den Wert der Schritte für die benötigte Drehung zu erhalten
 float stepAnzahl = (200 * multiplikator)/2;
 Serial.println(stepAnzahl);              // benötigte Anzahl Steps bei der Drehung

 digitalWrite(4, HIGH);
 digitalWrite(6, LOW);
 Serial.println("LINKS");
 for (int k = 0; k < stepAnzahl; k++)    // auf der Stelle drehen, Rad links bewegt sich, Rad rechts hält an
      {
      digitalWrite(5, HIGH);            
      digitalWrite(7, HIGH);             // for-Schleife ist ein Schritt auf beiden Rädern
      delayMicroseconds(500);             
      digitalWrite(5, LOW);             
      digitalWrite(7, LOW);             
      delayMicroseconds(500); 
      delay(50);
        }

        Serial.println("TEST2");
          pos = 75;
          servoEntfernungsmesser.write(pos);
          delay(500);
          messung = analogRead(A6);
          Serial.println(messung);
          if (messung < 300)
            {
              objectiveFound = false;
              Serial.println("TEST2 negativ -> kein Objekt mehr");
              klapp=0;
            }
           if(messung>300){                     //ServoKlapp hochfahren
             for (int i=0; i<125; i++){
               servoKlapp.write(5+i);
               delay(50);
                }
                klapp=130;
            }
}

//Funktion Roboter geradeaus fahren
void straight(float Strecke)
{
float multiplikator =  Strecke / (PI * 9);   // Strecke durch Umfamg des Rades teilen -> wie oft muss das Rad sich für die Strecke drehen?
float stepAnzahl = 200 * multiplikator;      //Steps, die das Rad für die Strecke benötigt
 
digitalWrite(4, HIGH);
digitalWrite(6, HIGH);

Serial.println("Jetzt nach vorne");
  for (int j = 0; j < stepAnzahl && objectiveFound == false; j++)   // geradeaus fahren für stepAnzahl
    {
   
      messung=analogRead(A6);
      lichtschranke = analogRead(A7);
      
      if (messung > 300 || lichtschranke < 650)         // -> der Wert, ab dem der Entfernungsmesser ein Objekt "zuverlässig" erkennt.
      {    
      Serial.println("TEST");                             
      objectiveFound = true;               // -> soll die for-Schleife abbrechen, wenn ein Objekt gefunden wurde und auch die if-Bedingung
      }                                    //nicht mehr weiter ausführen
    
      digitalWrite(5, HIGH);            
      digitalWrite(7, HIGH);              //for-Schleife ist ein Schritt auf beiden Rädern
      if(j%2==0){                         // nur bei Zahlen, die durch 2 teilbar sind, dreht sich der Servo um einen Grad
      pos = j/2+30;
      servoEntfernungsmesser.write(pos);  //Drehung von 30 nach 130
      }
      delayMicroseconds(500);             
      digitalWrite(5, LOW);             
      digitalWrite(7, LOW);             
      delayMicroseconds(500); 
      delay(50);
    }
  }




//Funktion Roboter geradeaus zum Objekt fahren
void straightTowardsGoal(float Strecke)
{
float multiplikator =  Strecke / (PI * 9);      //Strecke durch den Radumfang teilen
float stepAnzahl = 200 * multiplikator;         //Anzahl Steps, die er für die Strecke braucht
digitalWrite(4, HIGH);                          //Direction
digitalWrite(6, HIGH);

Serial.println("GERADEAUS");
if (klapp<130){
     for (int i=0; i<120; i++){
       servoKlapp.write(10+i);
       delay(20);
     }
    klapp=130;
  } 
     delay(100);
  for (int j = 0;j<stepAnzahl && lichtschranke > 650; j++)    // geradeaus fahren für stepAnzahl  // for-Schleife ist ein Schritt auf beiden Rädern 
    { 
      lichtschranke = analogRead(A7);
      Serial.println("Lichtschranke:  " + String(lichtschranke));
      digitalWrite(5, HIGH);            
      digitalWrite(7, HIGH);
      delayMicroseconds(500);             
      digitalWrite(5, LOW);             
      digitalWrite(7, LOW);             
      delayMicroseconds(500); 
      delay(50);
    }
    delay(2000);
    
    }

// Ansteuerung des Farbsensors; Aufruf mit: 0 = "R", 1 = "G", 2 = "B", 3 = "C"
int sensorRead (int channel) 
{
      if (channel == 0 || channel == 2) {
        digitalWrite(S2, LOW);
      }
      else {
        digitalWrite(S2, HIGH);
      }
     
      if (channel == 0 || channel == 3) {
        digitalWrite(S3, LOW);
      }
      else {
        digitalWrite(S3, HIGH);
      }
     
      int valueSensor = pulseIn(sensorOUT, LOW);
      return valueSensor;
    }

//Funktion für das Greifen
 float greifen(float Grad)
 {
  servoGreifarm1.write(100);
  servoGreifarm2.write(180);
  delay(1000); 
  Serial.println("START");
  for (int i = 0; i < 15; i++)
    {
      servoGreifarm1.write(100-i);  
      delay(50);  
    }
  Serial.println("180 Grad Drehung");
  digitalWrite(A2, HIGH);             // dreht sich mit dem Urhzeigersinn
  
  for (int i = 0; i < 100; i++)        // 180° Drehung des Steppers
    {           
      digitalWrite(A3, HIGH); 
      delay(3);             
      digitalWrite(A3, LOW);                          
      delay(3); 
      delay(10);
      Serial.println("180 Grad Drehung Schleife");
    }
   delay (1000);
    for (int i = 0; i < 10; i++)                 
    {
    servoGreifarm2.write(180-i);
    delay(50);
    }
   Serial.println("Greifarm1 einstellen");
  for (int i = 0; i < 95; i++)                  
    {
    servoGreifarm1.write(85+i);
    delay(50);
    }

  Serial.println("Elektromagnet anstellen");
  digitalWrite(10, HIGH);                       // Elektromagnet wird angeschaltet
  delay(1000);
  
  Serial.println("Greifarm1 heben");
  delay(1000);
  for (int i = 0; i < 95; i++)
  {
    servoGreifarm1.write(180-i);
    delay(50);
  }
  Serial.println("Greifarm2 senken");
  for (int i = 0; i < 30; i++)
  {
  servoGreifarm2.write(170-i);
  delay(50);
  }
  
  Serial.println("zu passendem Kasten drehen");
  delay(1000);

  digitalWrite(A2, LOW);
  for (int i = 0; i < (50 + Grad); i++)    
  {
    digitalWrite(A3, HIGH);
    delay(7);             
    digitalWrite(A3, LOW);                          
    delay(7); 
    
  }
  for (int i = 0; i < 15; i++)
  {
    servoGreifarm1.write(85+i);
    delay(50);
  }
  Serial.println("Elektromagneten ausstellen");
  delay(1000);
  digitalWrite(10, LOW);
  
  Serial.println("Arm auf Ausgangsposition zurückstellen");
  delay(1000);
  for (int i = 0; i < 15; i++)
  {
    servoGreifarm1.write(100-i);
    delay(50);
  }
  for (int i = 50; i > Grad; i = i - 1)
    {
      digitalWrite(A3, HIGH);
      delay(3);             
      digitalWrite(A3, LOW);                          
      delay(3);
      delay(10);
       
    }
  Serial.println("Greifarm2 zurückstellen");
  delay(1000);

  for (int i = 0; i < 15; i++)
    {
      servoGreifarm1.write(85+i);
      delay(50);
    }
  for (int i = 0; i < 40; i++)
    {
      servoGreifarm2.write(140+i);
      delay(50);
    }
  Serial.println("Greifarm1 zurückstellen");
 objectiveFound=false;
 delay(2000); 
 Serial.println("ENDE");
 }
